Updated installers, install directory can be set using NVM_DIR, profile can be set using NVM_PROFILE and source can be set by NVM_REPO and as NVM_SOURCE for the gitless installer.

This commit is contained in:
Koen Punt 2013-12-15 13:57:15 +01:00
parent 8573b95a2d
commit fddb1042f9
2 changed files with 69 additions and 62 deletions

View File

@ -1,59 +1,61 @@
#!/bin/bash #!/bin/bash
set -e
function fatalExit (){ function fatalExit (){
echo "$@" && exit 1; echo "$@" && exit 1;
} }
# an alternative URL that could be used: https://github.com/creationix/nvm/tarball/master if [ ! "$NVM_SOURCE" ]; then
if [ "$NVM_SOURCE" == "" ]; then NVM_SOURCE="https://raw.github.com/creationix/nvm/master/nvm.sh"
NVM_SOURCE="https://raw.github.com/creationix/nvm/master/nvm.sh"
fi fi
if [ "$NVM_DIR" == "" ]; then if [ ! "$NVM_DIR" ]; then
NVM_DIR="$HOME/.nvm" NVM_DIR="$HOME/.nvm"
fi fi
# Downloading to $NVM_DIR # Downloading to $NVM_DIR
mkdir -p "$NVM_DIR" mkdir -p "$NVM_DIR"
pushd "$NVM_DIR" > /dev/null pushd "$NVM_DIR" > /dev/null
echo -ne "=> Downloading... " echo -ne "=> Downloading... "
curl --silent "$NVM_SOURCE" -o nvm.sh || fatalExit "Failed"; curl --silent "$NVM_SOURCE" -o nvm.sh || fatalExit "Failed downloading $NVM_SOURCE"
echo "Downloaded" echo "Downloaded"
popd > /dev/null popd > /dev/null
# Detect profile file, .bash_profile has precedence over .profile # Detect profile file if not specified as environment variable (eg: NVM_PROFILE=~/.myprofile).
if [ ! -z "$1" ]; then if [ ! "$NVM_PROFILE" ]; then
PROFILE="$1"
else
if [ -f "$HOME/.bash_profile" ]; then if [ -f "$HOME/.bash_profile" ]; then
PROFILE="$HOME/.bash_profile" NVM_PROFILE="$HOME/.bash_profile"
elif [ -f "$HOME/.zshrc" ]; then
NVM_PROFILE="$HOME/.zshrc"
elif [ -f "$HOME/.profile" ]; then elif [ -f "$HOME/.profile" ]; then
PROFILE="$HOME/.profile" NVM_PROFILE="$HOME/.profile"
fi fi
fi fi
SOURCE_STR="[[ -s "$NVM_DIR/nvm.sh" ]] && . "$NVM_DIR/nvm.sh" # This loads NVM" SOURCE_STR="[ -s $NVM_DIR/nvm.sh ] && . $NVM_DIR/nvm.sh # This loads NVM"
if [ -z "$PROFILE" ] || [ ! -f "$PROFILE" ] ; then if [ -z "$NVM_PROFILE" ] || [ ! -f "$NVM_PROFILE" ] ; then
if [ -z $PROFILE ]; then if [ -z $NVM_PROFILE ]; then
echo "=> Profile not found" echo "=> Profile not found. Tried ~/.bash_profile ~/.zshrc and ~/.profile."
echo "=> Create one of them and run this script again"
else else
echo "=> Profile $PROFILE not found" echo "=> Profile $NVM_PROFILE not found"
echo "=> Create it (touch $NVM_PROFILE) and run this script again"
fi fi
echo "=> Append the following line to the correct file yourself" echo " OR"
echo "=> Append the following line to the correct file yourself:"
echo echo
echo "\t$SOURCE_STR" echo -ne "\t$SOURCE_STR"
echo echo
echo "=> Close and reopen your terminal to start using NVM"
exit
fi
if ! grep -qc 'nvm.sh' $PROFILE; then
echo "=> Appending source string to $PROFILE"
echo "" >> "$PROFILE"
echo $SOURCE_STR >> "$PROFILE"
else else
echo "=> Source string already in $PROFILE" if ! grep -qc 'nvm.sh' $NVM_PROFILE; then
echo "=> Appending source string to $NVM_PROFILE"
echo "" >> "$NVM_PROFILE"
echo $SOURCE_STR >> "$NVM_PROFILE"
else
echo "=> Source string already in $NVM_PROFILE"
fi
fi fi
echo "=> Close and reopen your terminal to start using NVM" echo "=> Close and reopen your terminal afterwards to start using NVM"

View File

@ -1,6 +1,14 @@
#!/bin/bash #!/bin/bash
NVM_DIR="$HOME/.nvm" set -e
if [ ! "$NVM_SOURCE" ]; then
NVM_SOURCE="https://github.com/creationix/nvm.git"
fi
if [ ! "$NVM_DIR" ]; then
NVM_DIR="$HOME/.nvm"
fi
if ! hash git 2>/dev/null; then if ! hash git 2>/dev/null; then
echo >&2 "You need to install git - visit http://git-scm.com/downloads" echo >&2 "You need to install git - visit http://git-scm.com/downloads"
@ -11,55 +19,52 @@ fi
if [ -d "$NVM_DIR" ]; then if [ -d "$NVM_DIR" ]; then
echo "=> NVM is already installed in $NVM_DIR, trying to update" echo "=> NVM is already installed in $NVM_DIR, trying to update"
echo -ne "\r=> " echo -ne "\r=> "
cd $NVM_DIR && git pull pushd "$NVM_DIR" > /dev/null
git pull --no-rebase origin master --quiet
popd > /dev/null
else else
# Cloning to $NVM_DIR # Cloning to $NVM_DIR
git clone https://github.com/creationix/nvm.git $NVM_DIR mkdir -p "$NVM_DIR"
git clone "$NVM_SOURCE" "$NVM_DIR"
fi fi
echo echo
# Detect profile file, .bash_profile has precedence over .profile # Detect profile file if not specified as environment variable (eg: NVM_PROFILE=~/.myprofile).
if [ ! -z "$1" ]; then if [ ! "$NVM_PROFILE" ]; then
PROFILE="$1"
else
if [ -f "$HOME/.bash_profile" ]; then if [ -f "$HOME/.bash_profile" ]; then
PROFILE="$HOME/.bash_profile" NVM_PROFILE="$HOME/.bash_profile"
elif [ -f "$HOME/.zshrc" ]; then elif [ -f "$HOME/.zshrc" ]; then
PROFILE="$HOME/.zshrc" NVM_PROFILE="$HOME/.zshrc"
elif [ -f "$HOME/.profile" ]; then elif [ -f "$HOME/.profile" ]; then
PROFILE="$HOME/.profile" NVM_PROFILE="$HOME/.profile"
fi fi
fi fi
SOURCE_STR="[ -s \$HOME/.nvm/nvm.sh ] && . \$HOME/.nvm/nvm.sh # This loads NVM" SOURCE_STR="[ -s $NVM_DIR/nvm.sh ] && . $NVM_DIR/nvm.sh # This loads NVM"
if [ -z "$PROFILE" ] || [ ! -f "$PROFILE" ] ; then if [ -z "$NVM_PROFILE" ] || [ ! -f "$NVM_PROFILE" ] ; then
if [ -z $PROFILE ]; then if [ -z $NVM_PROFILE ]; then
echo "=> Profile not found. Tried $HOME/.bash_profile and $HOME/.profile" echo "=> Profile not found. Tried ~/.bash_profile ~/.zshrc and ~/.profile."
echo "=> Create one of them and run this script again"
else else
echo "=> Profile $PROFILE not found" echo "=> Profile $NVM_PROFILE not found"
echo "=> Create it (touch $NVM_PROFILE) and run this script again"
fi fi
echo "=> Run this script again after running the following:" echo " OR"
echo "=> Append the following line to the correct file yourself:"
echo echo
echo "\ttouch $HOME/.profile" echo -ne "\t$SOURCE_STR"
echo echo
echo "-- OR --"
echo echo
echo "=> Append the following line to the correct file yourself"
echo
echo "\t$SOURCE_STR"
echo
echo "=> Close and reopen your terminal afterwards to start using NVM"
exit
fi
if ! grep -qc 'nvm.sh' $PROFILE; then
echo "=> Appending source string to $PROFILE"
echo "" >> "$PROFILE"
echo $SOURCE_STR >> "$PROFILE"
else else
echo "=> Source string already in $PROFILE" if ! grep -qc 'nvm.sh' $NVM_PROFILE; then
echo "=> Appending source string to $NVM_PROFILE"
echo "" >> "$NVM_PROFILE"
echo $SOURCE_STR >> "$NVM_PROFILE"
else
echo "=> Source string already in $NVM_PROFILE"
fi
fi fi
echo "=> Close and reopen your terminal to start using NVM" echo "=> Close and reopen your terminal afterwards to start using NVM"